# -*- coding: utf-8 -*-

"""
actions - WebFilterAdmin

Copyright (C) 2005 - Marco Andreini <m.andreini(at)tiscali.it>
GPL-2

"""

#from Globals import package_home

import os
import os.path


class MenuItem:
    """menu item"""
    
    subMenu = False
    
    def __init__(self, title, action):
        self.title = title
        self._action = action
    
    def url(self, base):
        """base url"""
        
        return "%s/%s" % (base, self._action)


class SubMenuItem(MenuItem):
    """sub menu item"""
    
    subMenu = True


class Menu:
    """menu"""
    
    def __init__(self, *args):
        items = []
        
        for arg in args:
            title, action = arg[:2]
            items.append(MenuItem(title, action))
            for item in arg[2:]:
                items.append(SubMenuItem(*item))
        self._items = items

    def __getitem__(self, i):
        """getitem"""
        
        return self._items[i]

    def __len__(self):
        """len"""

        return len(self._items)

    def getItems(self, base):
        """all items"""

        return [{"title": item.title,
                 "url": item.url(base),
                 "subMenu": item.subMenu} for item in self._items]

    __call__ = getItems


_admin_actions = Menu(
    {"id": "admin",
     "name": "Administration",
     "action": "admin",
     "permission": (ManageWebFilter, ),
     "category": "webfilteradmin"}
    {"id": "events",
     "name": "Events",
# XXX
        ('Eventi', 'events'),
        ('Siti permessi', 'exceptionsitelist/',
         ('URL permessi', 'exceptionurllist/'),
         ('IP permessi', 'exceptioniplist/'),
         ),
        ('Siti bloccati', 'bannedsitelist/',
         ('Estensioni bloccate', 'bannedextensionlist/'),
         ('Tipi MIME bloccati', 'banned<mimetypelist/'),
         ('URL bloccati', 'bannedurllist/'),
#         ('Regexp URL bloccati', 'bannedregexpurllist/'),
         ('IP bloccati', 'bannediplist/')
         ),
        ('Statistiche server', 'statistics/server',
         ('Settimanali', 'statistics/server/week'),
         ('Mensili', 'statistics/server/month'),
         ('Annuali', 'statistics/server/year')
         ),
        ('Statistiche client', 'statistics/client',
         ('Settimanali', 'statistics/client/week'),
         ('Mensili', 'statistics/client/month'),
         ('Annuali', 'statistics/client/year')
         ),
        ('Cerca nei log', 'search'),
        )

class ActionsMenu(object):
    """webfilteradmin actions"""

    def __init__(self):
        pass

    def getActions(self):
        """get actions"""

        
        
