-- MySQL
CREATE TABLE server (
serverId INTEGER PRIMARY KEY AUTO_INCREMENT,
hostname TEXT
);

CREATE TABLE client (
clientId INTEGER PRIMARY KEY AUTO_INCREMENT,
hostname TEXT
);

CREATE TABLE protocol (
protocolId INTEGER PRIMARY KEY AUTO_INCREMENT,
name TEXT
);

CREATE TABLE method (
methodId INTEGER PRIMARY KEY AUTO_INCREMENT,
name TEXT
);

CREATE TABLE log (
logId      INTEGER PRIMARY KEY AUTO_INCREMENT,
date       DATETIME,
clientId   INTEGER,
serverId   INTEGER,
protocolId INTEGER,
path       TEXT,
methodId   INTEGER,
size       INTEGER,
reason     INTEGER,
counter    INTEGER
);

CREATE TABLE request (
requestId INTEGER PRIMARY KEY AUTO_INCREMENT,
date      DATETIME,
url       TEXT,
message   TEXT,
client    TEXT,
detail    TEXT
);

CREATE index server_hostname_idx ON server (hostname);
CREATE index client_hostname_idx ON client (hostname);
CREATE index log_date_idx ON log (date);
