-- PostgreSQL
BEGIN;

CREATE SEQUENCE server_serverId_seq;

CREATE TABLE server (
serverId INT PRIMARY KEY DEFAULT NEXTVAL('server_serverId_seq'),
hostname TEXT
);

CREATE SEQUENCE client_clientId_seq;

CREATE TABLE client (
clientId INT PRIMARY KEY DEFAULT NEXTVAL('client_clientId_seq'),
hostname TEXT
);

CREATE SEQUENCE protocol_protocolId_seq;

CREATE TABLE protocol (
protocolId SMALLINT PRIMARY KEY DEFAULT NEXTVAL('protocol_protocolId_seq'),
name TEXT
);

CREATE SEQUENCE method_methodId_seq;

CREATE TABLE method (
methodId SMALLINT PRIMARY KEY DEFAULT NEXTVAL('method_methodId_seq'),
name TEXT
);

CREATE SEQUENCE log_logId_seq MAXVALUE 2147483647 CYCLE;

CREATE TABLE log (
logId      INT PRIMARY KEY DEFAULT NEXTVAL('log_logId_seq'),
date       TIMESTAMP,
clientId   INT REFERENCES client,
serverId   INT REFERENCES server,
protocolId SMALLINT REFERENCES protocol,
path       TEXT,
methodId   SMALLINT REFERENCES method,
size       INT,
reason     SMALLINT DEFAULT 0,
counter    SMALLINT DEFAULT 1
);

CREATE index server_hostname_idx ON server (hostname);
CREATE index client_hostname_idx ON client (hostname);
CREATE index log_date_idx ON log (date);

CREATE SEQUENCE request_requestId_seq;

CREATE TABLE request (
requestId  INT PRIMARY KEY DEFAULT NEXTVAL('request_requestId_seq'),
date       TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
url        TEXT,
message    TEXT,
client     TEXT,
detail     TEXT
);

END;
