-- SQLite
BEGIN;

CREATE TABLE server (
serverId INTEGER PRIMARY KEY,
hostname TEXT
);

CREATE TABLE client (
clientId INTEGER PRIMARY KEY,
hostname TEXT
);

CREATE TABLE protocol (
protocolId INTEGER PRIMARY KEY,
name TEXT
);

CREATE TABLE method (
methodId INTEGER PRIMARY KEY,
name TEXT
);

CREATE TABLE log (
logId      INTEGER PRIMARY KEY,
date       TIMESTAMP,
clientId   INTEGER,
serverId   INTEGER,
protocolId INTEGER,
path       TEXT,
methodId   INTEGER,
size       INTEGER,
reason     INTEGER,
counter    INTEGER
);

CREATE TABLE request (
requestId  INTEGER PRIMARY KEY,
date       TIMESTAMP,
url        TEXT,
message    TEXT,
client     TEXT,
detail     TEXT
);

CREATE index server_hostname_idx ON server (hostname) ON CONFLICT REPLACE;
CREATE index client_hostname_idx ON client (hostname) ON CONFLICT REPLACE;
CREATE index log_date_idx ON log (date) ON CONFLICT REPLACE;

END;
