#!/usr/bin/python
#
# WebFilterAdmin a web configurator for dansguardian & squid.
# Copyright (C) 2005 Marco Andreini
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

"""

minimal installer for WebFilterAdmin.

"""

__revision__ = "0.2"
__author__ = "Marco Andreini"

import os
import os.path
import sys

sudoers = "/etc/sudoers"
template = "/etc/dansguardian/languages/italian/template.html"
notifyURI = "http://%s/webfilteradmin/notify_form"

sudoEbnf = """
# webfilteradmin:
%s      ALL=NOPASSWD: /etc/init.d/dansguardian, /etc/init.d/squid
"""
webfilteradmin = "webfilteradmin"


def recreateTemplate(hostname):
    """recreate-template.html"""

    parameters = {"NotifyURI": notifyURI % hostname}

    source = open("template_source.html", "r")
    data = source.read()
    source.close()

    # overwrite...
    destination = open(template, "w")
    for key, value in parameters.items():
        data = data.replace("${%s}" % (key, ), value)
    destination.write(data)
    destination.close()

def addScriptsToSudoers(username):
    """add scripts to suoders"""

    # lock this file?
    sudoconf = open(sudoers, "r")
    text = sudoconf.read()
    sudoconf.close()
    if webfilteradmin in text:
        return
    
    sudoconf = open(sudoers, "w")
    sudoconf.write("\n".join(text, sudoEbnf % (username, )))
    sudoconf.close()
    
def installScripts(username):
    """install scripts"""

    cmds = """
chown -R %s /etc/dansguardian/
""" % (username, )
    for line in cmds.split("\n"):
        line = line.strip()
        if not line:
            continue
        os.system(line)

def main():
    """main installation"""
    
    try:
        hostname = sys.argv[1]
        username = sys.argv[2]
    except IndexError:
        print >> sys.stderr, "usage: %s ip[:port] zopeuser" % \
              (sys.argv[0], )
        sys.exit(1)
    
    if os.getuid() != 0:
        print >> sys.stderr, "require root privileges"
        sys.exit(1)

    recreateTemplate(hostname)
    installScripts(username)
    addScriptsToSudoers(username)

if __name__ == "__main__":
    main()

