## Script (Python) "search"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Cerca nei log
##

request = container.REQUEST
errors = {}
dateErrorStr = 'Inserire una data valida'

if not request.has_key('submitted'):
    return context.search_form()

def gotError():
    return context.search_form(
        message='\n'.join(errors.values()),
        errors=errors)

def getDate(key, n):
    date = request.get(key, None)
    if date is None:
        return DateTime() + n
    try:
        return DateTime(date)
    except DateTime.DateError:
        errors[key] = dateErrorStr
    except DateTime.SyntaxError:
        errors[key] = dateErrorStr
    return None

dateStart = getDate('dateStart', -1)
if errors:
    return gotError()
dateStop = getDate('dateStop', 0)
if errors:
    return gotError()

fields = [('Data e ora', 'date'),
          ('URL', 'server'),
          ('Client', 'client'),
          ('Dimensione', 'size'),
          ('Num', 'counter'),
          ('Stato', 'reason')]

if request.has_key('orderBy'):
    orderBy = request.orderBy
    if not orderBy in [v for l, v in fields]:
        errors['orderBy'] = 'Errore sull\'ordinamento'
else:
    orderBy = fields[0][1]

if errors:
    return gotError()

# hack: first check errors.
dateStop = dateStop.latestTime()

reason = request.get('reason', 0)

# FIXME: assert type(start) == type(limit) == int
start = request.get('start', 0)
limit = request.get('limit', 20)
reverse = request.get('reverse', None) and True or False
client = request.get('client', '').replace('*', '%')
server = request.get('server', '').replace('*', '%')
clientLike = request.get('clientLike', None) and True or False
serverLike = request.get('serverLike', None) and True or False

length = container.logSearchCount(dateStart=dateStart,
                                  dateStop=dateStop,
                                  serverName=server,
                                  serverLike=serverLike,
                                  clientName=client,
                                  clientLike=clientLike,
                                  reason=reason)[0][0]

if length == 0:
    return context.search_form(message='Nessun elemento trovato con i parametri forniti.')

rows = context.logSearch(dateStart=dateStart,
                         dateStop=dateStop,
                         serverName=server,
                         serverLike=serverLike,
                         clientName=client,
                         clientLike=clientLike,
                         reason=reason,
                         start=start,
                         limit=limit,
                         orderBy=orderBy,
                         reverse=reverse)

return context.search_results(length=length,
                              start=start,
                              fields=fields,
                              orderBy=orderBy,
                              results=rows)

