## Script (Python) "sqlBatch"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=start, length, perPage=20
##title=Genera i link avanti e indietro su un elenco
##
# perPage = number of items per page
# length  = total number of items
# start   = first item

from ZTUtils import url_query, make_query

request = container.REQUEST
form = request.form

perPage = int(perPage)
length = int(length)
start = int(start)

pagesMax = 2

url = url_query(request, req_name='ACTUAL_URL', omit='start')
if not url.endswith('?'):
    # assert url.rfind('&') < 0
    url += '&'

result = []
rAppend = result.append
if start:
    # ahem, plurale-singolare :)
    sp = perPage == 1 and 'e' or 'i'
    rAppend('<a href="%s" title="Visualizza precedent%s">&laquo; precedent%s</a> -' \
            % (url + make_query(start=max(start - perPage, 0)), sp, sp))


pageStart = start / perPage
pageFirst = max(0, pageStart - pagesMax)
if pageFirst != 0:
    rAppend('<a title="vai alla prima" href="%s">%d</a> &hellip;' % \
            (url + make_query(start=0), 1))

for i in range(pageFirst, pageStart):
    rAppend(' <a title="vai alla pagina %s" href="%s">%s</a>' % (i + 1, url + make_query(start=i * perPage), i + 1))
rAppend(' <strong>pagina %d</strong>' % (pageStart + 1, ))

pageEnd = length / perPage
if length % perPage:
    pageEnd += 1
realPages = pageEnd

if (pageEnd - pageStart) > pagesMax:
    pageEnd = pageStart + pagesMax

for i in range(pageStart + 1, pageEnd):
    rAppend(' <a title="vai alla pagina %s" href="%s">%s</a>' % (i + 1, url + make_query(start=i * perPage), i + 1))

if realPages != pageEnd:
    i = (realPages - 1) * perPage
    rAppend(' &hellip; <a title="vai all\'ultima" href="%s">%d</a>' % \
            (url + make_query(start=i), realPages))

if start + perPage < length:
    l = perPage == 1 and "o" or "i"
    rAppend(' - <a href="%s" title="Visualizza successiv%s">successiv%s &raquo;</a>' % \
            (url + make_query(start=start + perPage), l, l))

rAppend("""<br />da %d a %d di %d risultati""" % (start + 1, min(start + perPage, length), length))

return ''.join(result)
