
calendar = context.portal_calendar
request = container.REQUEST
try:
    date = DateTime(request['date'])
except KeyError:
    date = DateTime()
except ValueError:
    date = DateTime()

month = date.month()
year = date.year()
day = date.day()

try:
    typename = traverse_subpath[0]
except IndexError:
    typename = None
if typename != 'client':
    typename = 'server'

try:
    period = traverse_subpath[1]
except IndexError:
    period = None
if period == 'year':
    begin = DateTime(year, 1, 1)
    next = DateTime(year + 1, 1, 1)
    previous = DateTime(year - 1, 1, 1)
    end = (next - 1).latestTime()
elif period == 'week':
    end = date.latestTime()
    begin = (end - 6).earliestTime()
    previous = begin - 1
    next = end + 7
else: # month
    period = 'month'
    begin = DateTime(year, month, 1)
    previous = calendar.getPreviousMonth(month, year)
    next = calendar.getNextMonth(month, year)
    end = (next - 1).latestTime()

name = request.get('hostname', '').replace('*', '%')
try:
    start = int(request['start'])
except ValueError:
    start = 0
except KeyError:
    start = 0
    
counted = container.getStatsCount(
    typename=typename,
    name=name, like=1,
    dateStart=begin, dateStop=end)[0]

limit = 30
if not counted.num:
    rows = []
else:
    orderBy = request.get('orderBy', None)
    if not orderBy in ('hostname', 'hcounter', 'hsize'):
        # silently fix bad orderBy
        orderBy = 'hostname'
    reverse = request.get('reverse', None) and True or False
    rows = container.getStats(
        typename=typename,
        name=name, like=1,
        dateStart=begin, dateStop=end,
        start=start, limit=limit,
        orderBy=orderBy,
        reverse=reverse)

return context.stats_page(
    typename=typename,
    period=period,
    current=begin,
    currentEnd=end,
    previous=previous,
    next=next,
    rows=rows,
    totalSize=counted.size,
    totalCounter=counted.counter,
    length=counted.num
    )
